/*	Copyright 1992 H.Ogasawara (COR.)	*/
/*	modified for BMP 1998 Shinichi Honma	*/

#include	<corlib.h>
#include	<sys_doslib.h>
#include	"gview.h"
#include	"pislice.h"


extern int	loadBMPfile( picsliceinfo* );
extern int	drawBMP( picsliceinfo* );
extern void	EndOfDraw( picsliceinfo* );
extern void	psierr( char*, int );


GVIEW *
GV_Load_Bmp( fname )
char	*fname;
{
	char	format[]= "BMP";
	picsliceinfo	psi;
	int	ret;
	GVIEW	*gp;
	short	color;

	if( (psi.filehandle= OPEN( fname, 0 )) < 0 ){
		psierr( format, PICSLICE_EOPEN );
		return	NULL;
	}
	if( ( ret= loadBMPfile( &psi ) ) != PICSLICE_NORMAL ){
		psierr( format, ret );
		return NULL;
	}
	if( !(gp= GV_Alloc( psi.width, psi.height, psi.color,
					fname, NULL, 0 )) ){
		EndOfDraw( &psi );
		psierr( format, PICSLICE_NOMEMORY );
		return	NULL;
	}
	(unsigned short*)psi.chainbuf= gp->buf;
	if( ( ret= drawBMP( &psi ) ) != PICSLICE_TERMINATE ){
		psierr( format, ret );
		MFREE( gp );
		return	NULL;
	}
	if( color= psi.realwidth ){
		unsigned short	*str= gp->palet,
				*ptr= psi.palet;
		int	i;
		for( i= 0 ; i< color ; i++ ){
			*str++= *ptr++;
		}
	}
	return	gp;
}
