/*	Copyright 1992 H.Ogasawara (COR.)	*/
/*	modified 1998 by Shinichi Honma	*/

#include	<corlib.h>
#include	<sys_doslib.h>
#include	"gview.h"

#define		PNGLOADER	"pngl.x"

int
png_info( name, x, y )
char	*name;
int	*x;
int	*y;
{
	int	buf[8], ret;
	short	fn;

	/* wb_[h */
	if( ( fn= OPEN( name, 0 ) ) < 0 )	return FALSE;
	ret= READ( fn, buf, 4 * 8 );
	CLOSE( fn );
	if( ret < 4 * 8 )	return FALSE;

	/* wb_`FbN */
	if( buf[0] != 0x89504e47 || buf[1] != 0x0d0a1a0a
			|| buf[3] != 0x49484452 )	return FALSE;

	/* TCY擾 */
	*x= buf[4];
	*y= buf[5];

	return TRUE;
}

GVIEW *
GV_Load_Png( fname )
char	*fname;
{
	int	sizex, sizey;

	if( png_info( fname, &sizex, &sizey ) ){
		GVIEW	*gp;
		unsigned char	line[256]= "-VS$";
		if( !(gp= GV_Alloc( sizex, sizey, WindowAttrGraphic65536,
							fname, NULL, 0 )) ){
			GV_Err( "܂" );
			return	NULL;
		}else {
			unsigned int	i, num= (int)gp->buf;
			unsigned char	*str, *ptr;
			str= line + 4;
			for( i= 0 ; i< 6 ; i++, num<<= 4 ){
				*str++= ((char*)"0123456789abcdef")
							[(num >>20)&15];
			}
			*str++= ' ';
			for( ptr= fname ; *ptr ; *str++= *ptr++ );
			*str++= '\0';
		}
		ConsoleOpen();
		if( WindowLoadExec( PNGLOADER, line, NULL, ConsoleChar ) ){
			MFREE( gp );
			GV_Err2( PNGLOADER, "sł܂ł" );
			return	NULL;
		}
		WindowScreenInit();
		return	gp;
	}
	GV_Err2( fname, "t@C܂" );
	return	NULL;
}
