/*
	GLM	loader	for gview.win

	Copyright 1998 Shinichi Honma(Rick)
*/

#include	<corlib.h>
#include	<sys_doslib.h>
#include	"gview.h"
#include	"PICSLICE.H"

extern	void	psierr( char*, int );


GVIEW *
GV_Load_Glm( fname )
char	*fname;
{
	char	format[]= "GLM";
	GVIEW	*gp;
	int	sizex, sizey, fn;
	
	if( (fn= OPEN( fname, 0 )) < 0 ){
		psierr( format, PICSLICE_EOPEN );
		return	NULL;
	}else {
		unsigned char	Buffer[16 + 4];
		READ( fn, Buffer, 16 );
	    if ( Buffer[0] != 'G' || Buffer[1] != 'R' || Buffer[2] != '6'
	    		|| Buffer[3] != '5' ){
			CLOSE( fn );
			psierr( format, PICSLICE_EFORMAT );
			return	NULL;
		}
		sizex = ( Buffer[12] << 8 ) + Buffer[13];
		sizey = ( Buffer[14] << 8 ) + Buffer[15];
	}
	if( !(gp= GV_Alloc( sizex, sizey, WindowAttrGraphic65536,
						fname, NULL, 0 )) ){
		CLOSE( fn );
		psierr( format, PICSLICE_NOMEMORY );
		return	NULL;
	}
	if(	READ( fn, gp->buf, sizex * sizey * 2 ) < 0 ){
		CLOSE( fn );
		psierr( format, PICSLICE_EREAD );
		MFREE( gp );
		return	NULL;
	}
	CLOSE( fn );
	return gp;
}

