/*	Copyright 1992 H.Ogasawara (COR.)	*/

#include	<corlib.h>
#include	<sys_doslib.h>
#include	"gview.h"

GVIEW *
GV_UG_Open( ug )
UGraphic *ug;
{
	GVIEW	*gp;
	int	x, y;
	WindowGetGraphicOffset( &x, &y );
	if( !(gp= GV_Alloc( ug->h, ug->v, ug->color, "", NULL, 0 )) ){
		GV_Err( "܂" );
		return	NULL;
	}
	if( ug->color != WindowAttrGraphic65536 ){
		int	size= GV_PaletSize( ug->color );
		if( ug->palet ){
			memcpy( gp->palet, ug->palet, size*2 );
		}else
			GV_GetSysPalet( gp );
		GV_PaletToBase( gp );
		memcpy( gp->buf, ug->buf, ug->h*ug->v );
	}else
		memcpy( gp->buf, ug->buf, ug->h*ug->v*2 );
	GV_Open( x, y, gp );
	return	gp;
}

GVIEW *
GV_Sh_Open( sp )
Sheet	*sp;
{
	GVIEW	*gp;
	unsigned char	*str;
	unsigned short	*ptr1= (void*)sp->buf1, *ptr2= (void*)sp->buf2;
	int	x, y;
	int	sx, sy;

	WindowGetGraphicOffset( &x, &y );
	if( !(gp= GV_Alloc( sp->h, sp->v, WindowAttrGraphic16, "", NULL, 0 ) ) ){
		GV_Err( "܂" );
		return	NULL;
	}
	str= (unsigned char*)gp->buf;
	for( sy= 0 ; sy < sp->v ; sy++ ){
		for( sx= 0 ; sx < sp->hword ; sx++ ){
			unsigned short	a= *ptr1++,
							b= *ptr2++;
			int	i, t= (x+1<<4)-sp->h, cc= t< 0 ? 16 : 16-t;
			for( i= 0 ; i< cc ; i++ ){
				unsigned short	c= 0;
			/* 0, 14, 1, 15 */
				if( (short)a < 0 )
					c= 14;
				if( (short)b < 0 )
					c++;
				*str++= c;
				a+= a;
				b+= b;
			}
		}
	}
	GV_GetSysPalet( gp );
	GV_PaletToBase( gp );
	GV_Open( x, y, gp );
	return	gp;
}
